/***********************************************************************/
/*                                                                     */
/*                       C_data_user_rationnal.h                       */
/*                                                                     */
/*  example of definition of the C type rationnal                      */
/*                                                                     */
/*  authors: D. Gaffe and A. Ressouche                                 */
/*                                                                     */
/*  version: 03/06/2022                                                */
/***********************************************************************/

#ifndef C_DATA_USER_RATIONNAL_H
#define C_DATA_USER_RATIONNAL_H

typedef struct
{
  long long int num; /* numerator */
  unsigned long long int denom; /* denominator */
} rationnal;

extern const rationnal zero_rationnal;
extern rationnal copy_rationnal(rationnal);
extern rationnal add_rationnal(rationnal,rationnal);
extern rationnal sub_rationnal(rationnal,rationnal);
extern rationnal neg_rationnal(rationnal);
extern rationnal mult_rationnal(rationnal,rationnal);
extern rationnal div_rationnal(rationnal,rationnal);
extern int eq_rationnal(rationnal,rationnal);
extern int neq_rationnal(rationnal,rationnal);
extern int less_rationnal(rationnal,rationnal);
extern int lesseq_rationnal(rationnal,rationnal);
extern int sup_rationnal(rationnal,rationnal);
extern int supeq_rationnal(rationnal,rationnal);
#endif
